# Awesome Ethereum [![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome)

>  collection of best resources for ethereum development

*Please read the [contribution guidelines](.github/contributing.md) before contributing.*

![Ethereum](https://camo.githubusercontent.com/4331977d7fe4377c86fdd5e236e979c88c7461cc/68747470733a2f2f7777772e64726f70626f782e636f6d2f732f3377796274706b7331637839346b342f657468657265756d2e6a70673f7261773d31)

## Contents
- [架构](#architect)
- [教程](#tutorials)
- [视频](#videos)
- [工具](#tool)
- [文档](#documents)
- [SDK](#sdk)
- [优化](#enhance)
- [案例](#examples)

## Architect

- [以太坊白皮书](http://ethfans.org/wikis/以太坊白皮书) 讲解以太坊设计思路
- [以太坊黄皮书](http://yellowpaper.io) 论证以太坊技术可能性 [中文版](https://github.com/yuange1024/ethereum_yellowpaper/blob/master/Paper_Chinese.pdf)
- [The Ethereum Wiki](https://theethereum.wiki/w/index.php/Main_Page)
- [以太坊Gas使用](https://hackernoon.com/ether-purchase-power-df40a38c5a2f) Calculating Costs in Ethereum Contracts *(English)*
- [以太坊设计原理](http://ethfans.org/posts/510)
- [以太坊代码剖析](http://ethfans.org/topics/227)
- [以太坊源码阅读](http://www.cnblogs.com/baizx/category/1011749.html)
- [PoW模式下交易平均要35秒？](http://ethfans.org/posts/current-dynamics-of-transaction-inclusion-on-ethereum)

## Tutorials

- [以太坊从零开始入门](http://www.jianshu.com/p/220130b39e22)
- [以太坊开发入门经验](http://me.tryblockchain.org/getting-up-to-speed-on-ethereum.html)
- [Mac配置以太坊本地开发环境](https://my.oschina.net/wtsoftware/blog/782057)
- [以太坊智能合约编程之菜鸟教程](http://ethfans.org/posts/101-noob-intro)
- [以太坊Dapp开发入门](http://me.tryblockchain.org/getting-up-to-speed-on-ethereum.html)
- [区块链语言Solidity校验椭圆曲线加密数字签名（附实例）](http://www.toutiao.com/i6401418700217385473/?tt_from=weixin&utm_campaign=client_share&from=groupmessage&app=news_article&utm_source=weixin&iid=8932715408&utm_medium=toutiao_ios&wxshare_count=2&pbid=35867484354)
- [以太坊系列教程](http://gi1.cn/topics/category/solidity)
- [Create your own crypto-currency](https://www.ethereum.org/token) 来自以太坊官方的代币创建教程
- [ETHEREUM PET SHOP](http://truffleframework.com/tutorials/pet-shop) Truffle框架逐步案例教程
- [ROBUST SMART CONTRACTS WITH OPENZEPPELIN](http://zeppelin.tryblockchain.org/robust-smart-contracts-with-openzeppelin.html) OpenZeppelin集成Truffle编写健壮安全的合约
- [Truffle3.0案例教程](http://truffle.tryblockchain.org/truffle3.0-integrate-nodejs.html) 集成NodeJS并完全跑通，附详细实例和可能的错误
- [以太坊常见问题FAQ](http://8btc.com/thread-23195-1-1.html)
- [以太坊开发入门教程](http://blog.csdn.net/wo541075754/article/category/6502432/1)
- [EthList](https://github.com/Scanate/EthList) 以太坊开发相关学习资料收集
- [Defi Mooc教程](https://defi-learning.org/) Defi公开课程
- [useWeb3教程](https://www.useweb3.xyz/)
- [cryptozombies教程](https://cryptozombies.io/)
- [chainshot教程](https://www.chainshot.com/courses)

## Videos

- [Devcon 0 (Berlin, 2014) talks and videos](https://www.youtube.com/watch?v=_BvvUlKDqp0&amp;list=PLJqWcTqh_zKEjpSej3ddtDOKPRGl_7MhS) *(English)*
- [Devcon 1 (London, 2015) talks and videos](https://www.youtube.com/watch?v=BUARih8_f68&list=PLJqWcTqh_zKHQUFX4IaVjWjfT2tbS4NVk) *(English)*
- [Devcon 2 (Shanghai, 2016) talks and videos](https://www.youtube.com/watch?v=1wayaZ1-iBE&list=PLaM7G4Llrb7xqzgOwbvNv63_KM7VH84Rd) *(English)*
- [Devcon 3 (Cancún, 2017) talks and videos](https://www.youtube.com/watch?v=7BKegezSXIU&list=PLaOiBfasbC4nULu0Ikv55hR1FpmCfNDdB&ab_channel=EthereumFoundation) *(English)*
- [Devcon 4 (Prague, 2018) talks and videos](https://www.youtube.com/watch?v=xU-aCLSXk04&list=PLAvgWf9pPaiPNtLtHQI1TdYqDWKrwV5kl&ab_channel=EthereumFoundation) *(English)*
- [Devcon 5 (Osaka, 2019) talks and videos](https://www.youtube.com/watch?v=y9A8wHhNjJA&list=PLAvgWf9pPaiO3S1dWdnvrQuXJBy89JFXy&ab_channel=EthereumFoundation) *(English)*
- [Devcon 6 (Bogota, 2022) talks and videos](https://www.youtube.com/watch?v=h4MP1vwnyEE&list=PLaM7G4Llrb7wPaWK47GNSGvPoXUZGYVKX&ab_channel=EthereumFoundation) *(English)*

## Tool

### Explorer

- [Etherscan](https://etherscan.io) 以太坊区块链浏览器
- [Ethplorer](https://ethplorer.io) 以太坊区块链浏览器，提供API调用
- [Eth Gas Station](https://ethgasstation.info/index.php) 以太坊Gas目前定价

### Wallet

- [My Ether Wallet](https://myetherwallet.com) 网页版以太坊钱包 [源码](https://github.com/kvhnuke/etherwallet)
- [MetaMask](https://metamask.io/) Chrome Extension浏览器插件版
- [Multi-platform Jaxx Wallet](https://jaxx.io/) 同时兼容比特币钱包
- [Mist Wallet](https://github.com/ethereum/mist/releases/latest) 官方版钱包
- [Parity Wallet](https://github.com/paritytech/parity/releases/latest)
- [Harmony Wallet](https://github.com/ether-camp/ethereum-harmony/releases/latest)
- [imToken](https://token.im/) 移动App版钱包
- [Ledger Nano S](https://theethereum.wiki/w/index.php/Ledger_Nano_S) 硬件钱包
- [Trezor](https://blog.trezor.io/trezor-integration-with-myetherwallet-3e217a652e08) 硬件钱包

## Documents

- [Mastering Ethereum](https://github.com/ethereumbook/ethereumbook) 精通以太坊开发Oreilly开源书
- [Solidity语言文档](http://www.tryblockchain.org/) 语言中文手册
- [Web3.JS接口文档](http://web3.tryblockchain.org/) 接口中文手册
- [Truffle框架文档](http://truffle.tryblockchain.org/) 框架中文手册
- [Open Zeppelin框架文档](http://zeppelin.tryblockchain.org/)
- [Ethplorer接口](https://github.com/EverexIO/Ethplorer/wiki/Ethplorer-API?from=etop) Ethplorer接口文档

## SDK

- [Truffle](https://github.com/trufflesuite/truffle) 以太坊Dapp开发脚手架
- [Cakeshop](https://github.com/jpmorganchase/cakeshop) 来自JP Morgan的以太坊可视化管理工具
- [Zeppelin](https://github.com/OpenZeppelin/zeppelin-solidity) 用于编写安全的以太坊合约框架
- [Web3j](https://github.com/web3j/web3j) 以太坊官方轻量级java SDK

## Enhance

- [Quorum](https://github.com/jpmorganchase/quorum) 来自JP Morgan基于Go-Ethereum数据隐私加强的以太坊实现
- [BCOS](https://github.com/bcosorg/bcos) 来自微众银行的增强版以太坊实现
- [Presto-Ethereum](https://github.com/xiaoyao1991/presto-ethereum) 以太坊增加Presto的SQL访问能力

## Examples

### IM

- [status-im](https://github.com/status-im/status-network-token) status.im项目开源代码

### Social

- [dharma](https://dharma.io/) 第三方增信[源码](https://github.com/dharmaprotocol/dharma-cli)
- [Chronobank](https://chronobank.io/) 共享机制
- [slockit](https://github.com/slockit/smart-contract) Slock.it项目使用的智能合约

### Exchange

- [0x](https://www.0xproject.com/otc) 0x交易所[源码](https://github.com/0xProject/contracts)
- [ethdelf](https://etherdelta.github.io/#ZRX-ETH) etherdelta交易所[源码](https://github.com/etherdelta/smart_contract)
- [Dmarket](https://dmarket.io) dmarket交易所[源码](https://github.com/suntechsoft/dmarket-smartcontract)
- [augur](https://augur.net/) 对赌交易所[源码](https://github.com/AugurProject)
- [melonport](https://melonport.com/) 数字资产交易所[源码](https://github.com/melonproject)

### Cross Chain

- [Cosmos](https://cosmos.network) cosmos跨链交易，包括BTC到ETH[源码](https://github.com/cosmos)
- [polkadot](https://polkadot.io) polkadot跨链，实现了一个轻量级以太坊客户端[源码](https://github.com/paritytech/parity)

### Token

- [Token Sale](http://vitalik.ca/general/2017/06/09/sales.html) 代币销售模型
- [maker](https://makerdao.com/) Dai代币

### Defi

- [Uniswap](https://uniswap.org/) Uniswap [源码](https://github.com/Uniswap)
- [Synthetix](https://www.synthetix.io/) Synthetix 衍生品[源码](https://github.com/synthetixio)
- [Aave](https://aave.com/) Aave 借贷机制 [源码](https://github.com/aave)
- [Compound](https://compound.finance/governance/comp) Compound 借贷机制 [源码](https://github.com/compound-finance/compound-protocol)
- [MakerDao](https://makerdao.com/) MakerDao 做市Dai代币 [源码](https://github.com/makerdao)
- [Wrapped BTC](https://wbtc.network) BTC锚定资产 [源码](https://github.com/WrappedBTC/bitcoin-token-smart-contracts)
- [USDT](https://tether.to/) USDT稳定币

## License

[![CC0](http://mirrors.creativecommons.org/presskit/buttons/88x31/svg/cc-zero.svg)](https://creativecommons.org/publicdomain/zero/1.0/)

To the extent possible under law, [Chaozh](http://www.chaozh.com) has waived all copyright and related or neighboring rights to this work.
