# Awesome Blockchain [![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome)

>  收集所有区块链(BlockChain)技术开发相关资料

*Please read the contribution [guidelines](https://github.com/sindresorhus/awesome/blob/master/contributing.md) before contributing. 请在为本项目贡献信息前仔细阅读 [操作指南](https://github.com/sindresorhus/awesome/blob/master/contributing.md)*

欢迎到Issues提交区块链相关项目，我们会第一时间处理。
提交的项目格式如下：
项目名称：XXXXX
相关介绍: XXXXXX

## CONTENTS

- [INTRO 介绍](#intro-%E4%BB%8B%E7%BB%8D)
- [TUTORIAL 教程](#tutorial-%E6%95%99%E7%A8%8B)
- [PROJECT 项目](#project-%E9%A1%B9%E7%9B%AE)
- [DOCUMENT 资料](#document-%E8%B5%84%E6%96%99)
- [APPLICATION 应用](#application-%E5%BA%94%E7%94%A8)

## INTRO 介绍 

### Started 入门 

- [（一）简单易懂地介绍什么是区块链](https://zhuanlan.zhihu.com/p/22228902) 比特币区块链关键词讲解
- [（二）简单易懂地介绍什么是区块链（技术篇）](https://zhuanlan.zhihu.com/p/23243289) 比特币区块链技术图解
- [一文看懂区块链：一步一步发明比特币](https://charlesliuyx.github.io/2017/09/24/%E4%B8%80%E6%96%87%E5%BC%84%E6%87%82%E5%8C%BA%E5%9D%97%E9%93%BE-%E4%BB%A5%E6%AF%94%E7%89%B9%E5%B8%81%E4%B8%BA%E4%BE%8B/)
- [一步一步学区块链](http://blog.csdn.net/jwter87/article/details/53322642) 按步骤的实际操作入门指南
- [区块链技术指南](https://yeasy.gitbooks.io/blockchain_guide) 区块链领域比较系统的入门资料
- [理解区块链](http://blog.csdn.net/csolo/article/details/52858236) 区块链关键技术要点讲解
- [一文看懂区块链架构设计](http://www.8btc.com/ebook-blockchain) 从技术分层解构架构
- [共识算法与如何解决拜占庭将军问题](https://charlesliuyx.github.io/2018/03/03/%E3%80%90%E5%8C%BA%E5%9D%97%E9%93%BE%E3%80%91%E5%A6%82%E4%BD%95%E8%A7%A3%E5%86%B3%E6%8B%9C%E5%8D%A0%E5%BA%AD%E5%B0%86%E5%86%9B%E9%97%AE%E9%A2%98/)
- [Blockchain Demo](https://blockchaindemo.io/)  A visual demo of blockchain technology
- [Defi Mooc教程](https://defi-learning.org/) Defi公开课程

### Ethereum 以太坊进阶

- [区块链技术-智能合约-以太坊](http://ethfans.org/posts/block-chain-technology-smart-contracts-and-ethereum) 以太坊智能合约入门概念
- [以太坊白皮书](http://ethfans.org/wikis/以太坊白皮书)
- [The Ethereum Wiki](https://theethereum.wiki/w/index.php/Main_Page) *(English)*
- [以太坊设计原理](http://ethfans.org/posts/510)
- [以太坊Dapp开发入门](http://me.tryblockchain.org/getting-up-to-speed-on-ethereum.html)
- [以太坊Gas使用](https://hackernoon.com/ether-purchase-power-df40a38c5a2f) Calculating Costs in Ethereum Contracts *(English)*
- [以太坊代码剖析](http://ethfans.org/topics/227)
- [以太坊源码阅读](http://www.cnblogs.com/baizx/category/1011749.html)
- [Merkle Tree学习](http://blog.csdn.net/jiange_zh/article/details/53386250) 
- [以太坊的指南针](https://github.com/laalaguer/ethereum-compass)


### Fabric 联盟链进阶

- [Blockchain区块链架构设计之一：成员管理](https://zhuanlan.zhihu.com/p/23356616)
- [Blockchain区块链架构设计之二：分布式账本技术对比](https://zhuanlan.zhihu.com/p/23463699)
- [Blockchain区块链架构设计之三：Hyperledger Fabric介绍](https://zhuanlan.zhihu.com/p/23947372)
- [Blockchain区块链架构设计之四：Fabric多通道和下一代账本设计](https://zhuanlan.zhihu.com/p/24605987)
- [Blockchain区块链架构设计之五：让DLT产生协作，对Corda和GSL的思考](https://zhuanlan.zhihu.com/p/25061575)
- [Blockchain区块链架构设计之六：Fabric 1.0账本设计（1）](https://zhuanlan.zhihu.com/p/25119939)
- [Blockchain区块链架构设计之七：Fabric 1.0 Endorse背书策略](https://zhuanlan.zhihu.com/p/25295608)
- [Hyperledger架构解读：Hyperledger Fabric1.0架构概览](http://www.wanbizu.com/blockchain/201702078984.html)

## TUTORIAL 教程

### BitCoin 比特币

- [Bitcoin and Cryptocurrency Technologies](https://www.coursera.org/learn/cryptocurrency) Cousera上的比特币教程 *(English)*

### Ethereum 以太坊

- [以太坊从零开始入门](http://www.jianshu.com/p/220130b39e22)
- [以太坊开发入门经验](http://me.tryblockchain.org/getting-up-to-speed-on-ethereum.html)
- [以太坊智能合约编程之菜鸟教程](http://ethfans.org/posts/101-noob-intro)
- [Solidity智能合约](https://github.com/WTFAcademy/WTF-Solidity-Internals) 介绍Solidity智能合约中的存储布局，内存布局，以及ABI编码规则，帮助大家理解Solidity的内部规则。
- [区块链语言Solidity校验椭圆曲线加密数字签名（附实例）](http://www.toutiao.com/i6401418700217385473/?tt_from=weixin&utm_campaign=client_share&from=groupmessage&app=news_article&utm_source=weixin&iid=8932715408&utm_medium=toutiao_ios&wxshare_count=2&pbid=35867484354)
- [Create your own crypto-currency](https://www.ethereum.org/token) 来自以太坊官方的代币创建教程 *(English)*
- [ETHEREUM PET SHOP](http://truffleframework.com/tutorials/pet-shop) Truffle框架逐步案例教程 *(English)*
- [ROBUST SMART CONTRACTS WITH OPENZEPPELIN](http://zeppelin.tryblockchain.org/robust-smart-contracts-with-openzeppelin.html) OpenZeppelin集成Truffle编写健壮安全的合约 *(English)*
- [Truffle3.0案例教程](http://truffle.tryblockchain.org/truffle3.0-integrate-nodejs.html) 集成NodeJS并完全跑通，附详细实例和可能的错误 *(English)*
- [以太坊开发入门教程](http://blog.csdn.net/wo541075754/article/category/6502432/1)
- [useWeb3教程](https://www.useweb3.xyz/) web3开发教程合集 *(English)*
- [cryptozombies教程](https://cryptozombies.io/) solidity游戏式教程 *(English)*
- [chainshot教程](https://www.chainshot.com/courses) web3开发教程合集 *(English)*
- [smartcontract教程](https://www.smartcontract.engineer/)  solidity leetcode模式教程 *(English)*
- [solidity案例教程](https://solidity-by-example.org/app/ether-wallet/) solidity案例学习 *(English)*

### Fabric 联盟链

- [Fabric Basics](https://github.com/angrbrd/hyperledger-fabric-basics)  使用Docker Toolbox来搭建Fabric的开发环境 *(English)*
- [Learn Chaincode](https://github.com/IBM-Blockchain/learn-chaincode) Fabric Chaincode入门 *(English)*
- [Marbles Project Tutorial: Part One](https://github.com/IBM-Blockchain/marbles/blob/master/docs/tutorial_part1.md) 官方Chaincode案例教程第一部分 *(English)*
- [Marbles Project Tutorial: Part Two](https://github.com/IBM-Blockchain/marbles/blob/master/docs/tutorial_part2.md) 官方Chaincode案例教程第二部分 *(English)*
- [Hyperledger Fabric V1.0– 开发者快速入门](https://zhuanlan.zhihu.com/p/25070745) 这个是基于baseos 0.2.2 的
- [搭建运行Fabric V1.0-alpha版本](http://blog.csdn.net/kojhliang/article/details/66971404) 针对Fabric1.0版本的开发环境搭建指引
- [Fabric v1.0-alpha 开发镜像编译](http://blog.csdn.net/remote_roamer/article/details/70228662) 使用Fabric源码编译v1.0-alpha版本的Docker镜像指引
- [Hyperledger Composer使用入门](http://www.jianshu.com/p/7bc258810b77) 官方Fabric应用开发工具Hyperledger Composer入门
- [Fabric-CA-1.0-Alpha小结](http://www.jianshu.com/p/ec7d4216c3cf)

### Videos 视频

- [Devcon 0 (Berlin, 2014) talks and videos](https://www.youtube.com/watch?v=_BvvUlKDqp0&amp;list=PLJqWcTqh_zKEjpSej3ddtDOKPRGl_7MhS) *(English)*
- [Devcon 1 (London, 2015) talks and videos](https://www.youtube.com/watch?v=BUARih8_f68&list=PLJqWcTqh_zKHQUFX4IaVjWjfT2tbS4NVk) *(English)*
- [Devcon 2 (Shanghai, 2016) talks and videos](https://www.youtube.com/watch?v=1wayaZ1-iBE&list=PLaM7G4Llrb7xqzgOwbvNv63_KM7VH84Rd) *(English)*
- [Devcon 3 (Cancún, 2017) talks and videos](https://www.youtube.com/watch?v=7BKegezSXIU&list=PLaOiBfasbC4nULu0Ikv55hR1FpmCfNDdB&ab_channel=EthereumFoundation) *(English)*
- [Devcon 4 (Prague, 2018) talks and videos](https://www.youtube.com/watch?v=xU-aCLSXk04&list=PLAvgWf9pPaiPNtLtHQI1TdYqDWKrwV5kl&ab_channel=EthereumFoundation) *(English)*
- [Devcon 5 (Osaka, 2019) talks and videos](https://www.youtube.com/watch?v=y9A8wHhNjJA&list=PLAvgWf9pPaiO3S1dWdnvrQuXJBy89JFXy&ab_channel=EthereumFoundation) *(English)*
- [Devcon 6 (Bogota, 2022) talks and videos](https://www.youtube.com/watch?v=h4MP1vwnyEE&list=PLaM7G4Llrb7wPaWK47GNSGvPoXUZGYVKX&ab_channel=EthereumFoundation) *(English)*

### Roadmaps 路线图

- [Blockchain Roadmap](https://roadmap.sh/blockchain)
- [Roadmap of learning blockchain](https://github.com/Blockchain-zju/blockchainer-roadmap)
- [DeFi Developer Roadmap](https://github.com/OffcierCia/DeFi-Developer-Road-Map)

## PROJECT 项目

### Chain 区块链底层

- [Metaverse](https://github.com/mvs-org/metaverse) 原界链源码
- [EOS](https://github.com/EOSIO/eos) EOS链源码
- [BYTOM](https://github.com/Bytom/bytom) 比原链源码
- [NEO](https://github.com/neo-project/neo) NEO链源码
- [CITA](https://github.com/cryptape/cita) cita联盟链的底层源码
- [Nervos](https://github.com/nervosnetwork/ckb) 公链 Nervos CKB 的底层源码
- [比特币0.1](https://github.com/fkysly/bitcoin0.1.0) 最原始的比特币代码
- [Quorum](https://github.com/jpmorganchase/quorum) 来自JP Morgan基于Go-Ethereum数据隐私加强的以太坊实现
- [FISCO-BCOS](https://github.com/FISCO-BCOS/FISCO-BCOS) 来自金链盟的聚焦金融行业的区块链底层平台
- [Presto-Ethereum](https://github.com/xiaoyao1991/presto-ethereum) 以太坊增加Presto的SQL访问能力
- [IPFS](https://github.com/ipfs/go-ipfs) IPFS的GO语言实现 [原理](https://github.com/ipfs/ipfs)

### SDK 工具包

- [Remix](https://ethereum.github.io/browser-solidity/) 在线以太坊编译器
- [Truffle](https://github.com/trufflesuite/truffle) 以太坊Dapp开发脚手架
- [Zeppelin](https://github.com/OpenZeppelin/zeppelin-solidity) 用于编写安全的以太坊合约框架
- [Web3j](https://github.com/web3j/web3j) 以太坊官方Web3轻量级java SDK
- [Embark](https://github.com/embark-framework/embark) 以太坊Dapp开发框架，支持IPFS、Whisper及Orbit调用 
- [Web3Swift](https://github.com/BANKEX/web3swift) 一个Web3的swift SDK
- [Porosity](https://github.com/comaeio/porosity) 反编译以太坊智能合约工具
- [Solidity-Coverage](https://github.com/sc-forks/solidity-coverage) 检测Solidity代码覆盖
- [Caliper](https://github.com/hyperledger-archives/caliper) hyperledger区块链性能测试工具
- [Composer](https://github.com/hyperledger/composer) 官方可视化Fabric应用开发框架
- [Cakeshop](https://github.com/jpmorganchase/cakeshop) 来自JP Morgan的以太坊可视化管理工具
- [btcschools.net](https://www.btcschools.net) 一个区块链的PHP SDK

### Research 最新研究

- [eWASM](https://github.com/ewasm/design) 让以太坊支持WebAssembly
- [FSolidM](https://cps-vo.org/group/SmartContracts) 可视化智能合约生成工具 [源码](https://github.com/anmavrid/smart-contracts)
- [Maian](https://github.com/MAIAN-tool/MAIAN) 以太坊智能合约漏洞查找工具
- [Oyente](https://github.com/melonproject/oyente) 以太坊智能合约分析工具
- [Blockbench](https://github.com/ooibc88/blockbench) 区块链性能测试工具
- [Zokrates](https://github.com/JacobEberhardt/ZoKrates) 以太坊使用zkSNARKS工具包(实验用)
- [libsnark](https://github.com/scipr-lab/libsnark) zkSNARKS C++库


## DOCUMENT 资料

### BitCoin 比特币

- [精通比特币](https://github.com/bitcoinbook/bitcoinbook) 精通比特币开发Oreilly开源书 [中文翻译版](https://github.com/tianmingyun/MasterBitcoin2CN)
- [blockchaindev.org](http://blockchaindev.org/) 区块链创业公司维优CTO的专栏
- [区块链研习社](http://www.jianshu.com/u/30081a05cf95) 比特币源码解读

### Ethereum 以太坊

- [Mastering Ethereum](https://github.com/ethereumbook/ethereumbook) 精通以太坊开发Oreilly开源书
- [区块链技术博客](http://me.tryblockchain.org/) 关注以太坊
- [以太坊系列教程](http://gi1.cn/topics/category/solidity) solidity语言学习
- [Solidity语言文档](http://www.tryblockchain.org/) 语言中文手册
- [Web3.JS接口文档](http://web3.tryblockchain.org/) 接口中文手册
- [Truffle框架文档](http://truffle.tryblockchain.org/) 框架中文手册
- [Open Zeppelin框架文档](http://zeppelin.tryblockchain.org/) 框架中文手册
- [Ethplorer接口](https://github.com/EverexIO/Ethplorer/wiki/Ethplorer-API?from=etop) Ethplorer接口文档
- [以太坊常见问题FAQ](http://8btc.com/thread-23195-1-1.html)
- [Ethereum Smart Contract Security Best Practices](https://consensys.github.io/smart-contract-best-practices/) *(English)*
- [EthList](https://github.com/Scanate/EthList) 以太坊开发相关学习资料收集 *(English)*
- [以太坊开发者工具列表](https://github.com/ConsenSys/ethereum-developer-tools-list/blob/master/README_Chinese.md) 以太坊开发资料收集

### Fabric 联盟链

- [Fabric Official Docs](https://hyperledger-fabric.readthedocs.io/en/latest/) Fabric官方最新文档
- [yeasy的专栏](http://blog.csdn.net/yeasy) IBM fabric核心开发者yeasy的专栏
- [菜鸟的博客](http://blog.csdn.net/xjmtxwd24/) fabric0.6及1.0源码分析
- [jiang_xinxing的博客](http://blog.csdn.net/jiang_xinxing/article/category/6642179) fabric0.6源码分析

## APPLICATION 应用 

### Explorer 链浏览

- [Blockchain](https://blockchain.info) 比特币区块链浏览器
- [Etherscan](https://etherscan.io) 以太坊区块链浏览器
- [Ethplorer](https://ethplorer.io) 以太坊区块链浏览器，提供API调用
- [Eth Gas Station](https://ethgasstation.info/index.php) 以太坊Gas目前定价
- [Etherscope](https://etherscope.io) 以太坊区块链浏览器
- [Oklink](https://www.oklink.com/eth/defi) Defi市场状况浏览器
- [Tokenview](https://tokenview.io) The General Multi-chain Explorer and Blockchain API
- [3xpl](https://3xpl.com) 最快的无广告通用区块浏览器

### Wallet 钱包

- [My Ether Wallet](https://myetherwallet.com) 网页版以太坊钱包 [源码](https://github.com/kvhnuke/etherwallet)
- [MetaMask](https://metamask.io/) Chrome Extension浏览器插件版
- [Multi-platform Jaxx Wallet](https://jaxx.io/) 同时兼容以太坊和比特币钱包
- [Mist Wallet](https://github.com/ethereum/mist/releases/latest) 官方版轻量级钱包
- [Parity Wallet](https://github.com/paritytech/parity/releases/latest) 
- [Harmony Wallet](https://github.com/ether-camp/ethereum-harmony/releases/latest)
- [imToken](https://token.im/) 移动App版钱包
- [Trust](https://trustwalletapp.com/) iOS / Android 原生钱包 + DApp 浏览器
- [Cipher](https://www.cipherbrowser.com/) iOS / Android 钱包 + DApp 浏览器
- [Ledger Nano S](https://theethereum.wiki/w/index.php/Ledger_Nano_S) 硬件钱包
- [Trezor](https://blog.trezor.io/trezor-integration-with-myetherwallet-3e217a652e08) 硬件钱包
- [DeBank](https://debank.com/) 以太坊 DeFi 钱包
- [web3modal](https://github.com/WalletConnect/web3modal) Web3 provider solution for all Wallets

### Exchange 交易所

- [0x](https://www.0xproject.com/otc) 0x交易所平台 [源码](https://github.com/0xProject/contracts)
- [IDEX](https://idex.market) IDEX交易所，目前最活跃 [源码](https://github.com/AuroraDAO)
- [ethdelf](https://etherdelta.github.io/#ZRX-ETH) etherdelta交易所 [源码](https://github.com/etherdelta/smart_contract)
- [forkdelta](https://forkdelta.github.io) forkdelta交易所,较活跃 [源码](https://github.com/forkdelta/smart_contract)
- [kyber](https://kyber.network/) kyber交易所 [源码](https://github.com/kyberNetwork/smart_contract)
- [Dmarket](https://dmarket.io) dmarket交易所 [源码](https://github.com/suntechsoft/dmarket-smartcontract)
- [augur](https://augur.net/) 对赌交易所 [源码](https://github.com/AugurProject)
- [melonport](https://melonport.com/) 数字资产交易所 [源码](https://github.com/melonproject)

### Defi 去中心化金融

- [Uniswap](https://uniswap.org/) Uniswap [源码](https://github.com/Uniswap)
- [Synthetix](https://www.synthetix.io/) Synthetix 衍生品[源码](https://github.com/synthetixio)
- [Aave](https://aave.com/) Aave 借贷机制 [源码](https://github.com/aave)
- [Compound](https://compound.finance/governance/comp) Compound 借贷机制 [源码](https://github.com/compound-finance/compound-protocol)
- [MakerDao](https://makerdao.com/) MakerDao 做市Dai代币 [源码](https://github.com/makerdao)
- [Wrapped BTC](https://wbtc.network) BTC锚定资产 [源码](https://github.com/WrappedBTC/bitcoin-token-smart-contracts)
- [USDT](https://tether.to/) USDT稳定币

### Game 游戏

- [CryptoKitties](https://www.cryptokitties.co/) 以太猫
- [Etheremon](https://www.etheremon.com/#/) 以太神奇宝贝
- [Edgeless](https://www.edgeless.io/) 虚拟币在线赌场 [源码](https://github.com/EdgelessCasino/Smart-Contracts)

### IM 通信

- [status-im](https://github.com/status-im/status-network-token) status.im项目开源代码
- [nostr](https://github.com/nostr-protocol/nostr) Nostr协议目录
- [nostr-rs-relay](https://github.com/scsibug/nostr-rs-relay) Nostr Relay Rust实现
  
### Social 社会

- [Oraclize](http://docs.oraclize.it/#background) 第三方信息提供
- [Aragon](https://aragon.one/) 公司业务 [源码](https://github.com/aragon/aragon-core/tree/master/contracts)
- [dharma](https://dharma.io/) 第三方增信 [源码](https://github.com/dharmaprotocol/dharma-cli)
- [Chronobank](https://chronobank.io/) 共享机制
- [slockit](https://slock.it/) 租借智能设备 [源码](https://github.com/slockit/smart-contract)
- [DAO](https://github.com/slockit/DAO) DAO提案

### Cross Chain 跨链

- [Cosmos](https://cosmos.network) cosmos跨链交易，包括BTC到ETH [源码](https://github.com/cosmos)
- [polkadot](https://polkadot.io) polkadot跨链，实现了一个轻量级以太坊客户端 [源码](https://github.com/paritytech/parity)

### Token 代币

- [ERC20](https://github.com/ethereum/EIPs/pull/610) 以太坊的ICO代币标准
- [Token Sale](http://vitalik.ca/general/2017/06/09/sales.html) 代币销售模型
- [NFT](https://www.nft.org/) NFT代币

## [Awesome Ethereum](https://github.com/chaozh/awesome-blockchain/tree/master/Ethereum) 

以太坊相关详细开发资源收集

## [Awesome Fabric](https://github.com/chaozh/awesome-blockchain/tree/master/Hyperledger%20Fabric) 

Fabric联盟链相关详细开发资源收集

## DONATE 赞助

BTC：1JnC15WwDVcC3QbQRUY6ChqRLucLpTGaJN

ETH：0x81847890eecdecb20ee145824eaa1aec079a712c

## License

[![CC0](http://mirrors.creativecommons.org/presskit/buttons/88x31/svg/cc-zero.svg)](https://creativecommons.org/publicdomain/zero/1.0/)

To the extent possible under law, [Chaozh](http://www.chaozh.com) has waived all copyright and related or neighboring rights to this work.
